/*
 * dingdictionary.h
 *
 * Copyright (c) 2005 Michael Rex <me@rexi.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef DINGDICTIONARY_H
#define DINGDICTIONARY_H

#include "resultitem.h"
#include <qstring.h>
#include <qobject.h>

class QProcess;

/**
 * 
 * @author Michael Rex
 */
class DingDictionary : public QObject {
    Q_OBJECT

public:
    DingDictionary(QObject* parent = 0, const char* name = 0);
    ~DingDictionary();
    
    void search(const QString& text);
    const ResultList& results() const;
    const QString& searchTerm() const;
    const QString& dictionaryVersion() const;
    
signals:
    void searchFinished();
    void searchRunning();

private slots:
    void readDataFromProcess();

private:
    void sortByPriority(ResultList* list);
    QString determineDictionaryVersion();
    
    const QString PATH;
    const QString VERSION;
    
    QString search_term;
    QProcess* proc;
    ResultList* reslist;
};

#endif
