/*
 * resultitem.h
 *
 * Copyright (c) 2006 Michael Rex <me@rexi.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef RESULTITEM_H
#define RESULTITEM_H

#include <qstring.h>
#include <qvaluelist.h>

/**
 * @author Michael Rex
 */
class ResultItem {

public:
    ResultItem(const QString& text = 0, const int priority = 0);
    ~ResultItem();
    
    QString text() const;
    void setText(const QString& text);
    
    int priority() const;
    void setPriority(const int priority);
    void addToPriority(const int priority);
    
    bool operator<(const ResultItem& other) const;
    
private:
    QString str;
    int prio;
};

/**
 *
 */
typedef QValueList<ResultItem> ResultList;

#endif
