/*
 * translatedialog.h
 *
 * Copyright (c) 2005 Michael Rex <me@rexi.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef TRANSLATEDIALOG_H
#define TRANSLATEDIALOG_H

#include "translatedialogbase.h"
#include "dingdictionary.h"
#include "resultitem.h"
#include <kurl.h>
#include <qstring.h>
#include <qcolor.h>

class KConfig;
class KHTMLPart;
class KAnimWidget;
class KStatusBar;

/**
 * @author Michael Rex
 */
class TranslateDialog : public TranslateDialogBase {
    Q_OBJECT

public:
    TranslateDialog(QWidget* parent = 0, const char* name = 0);
    ~TranslateDialog();
    virtual void translate(const QString& text);
    
public slots:
    virtual void translateClicked();
    virtual void historyCleared();
    virtual void clearDialog();
    virtual void fetchResults();
    virtual void textChanged(const QString&);
    virtual void searchAlreadyRunning();

protected:
    void resizeEvent(QResizeEvent*);

private:
    DingDictionary dict;
    KHTMLPart* htmlpart;
    KAnimWidget* animSearch;
    KStatusBar* statusBar;
    
    QString getDocument(const ResultList&, const QString&);
    
    static const int SB_MESSAGE = 0;
    
    static KURL getCSSLocation();
    static KURL getWelcomeLocation();
};

#endif
